local MOUNTS_TO_DISPLAY = 17;
local MRM_FRAME_MOUNT_HEIGHT = 16;
local MRM_Frame_PAGENUM = 1;
local MRM_Frame_CurPAGENUM = 1;
local MRM_Total_MountsShown = 0
function MRMFrameButton_OnClick(self, button)
	
end

function MountRandomMount_GUI(hide)
	for i = 1, 24 do
		_G["MRMGUIMainFrame_MountLabel"..i]:SetText("")
		_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Disable()
		_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Hide()
		_G["MRMGUIMainFrame_Mount_CheckButton"..i]:SetChecked(false)
	end
	if (hide) then
		MRMMainFrame:Hide()
	else
		
		if (GetNumCompanions("MOUNT") > 0) then
			if (GetNumCompanions("MOUNT") > 24) then
				for i = 1, 24 do
					creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
					_G["MRMGUIMainFrame_MountLabel"..i]:SetText(i..". "..creatureName)
					_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Enable()
					_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Show()
					creatureName = string.lower(creatureName)
					for j = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
						
						if (creatureName == MountRandomMount_SavedTable.randommountlist["Flying"][j][1]) then
							_G["MRMGUIMainFrame_Mount_CheckButton"..i]:SetChecked(true)
							break
						end
					end
					for j = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
						if (creatureName == MountRandomMount_SavedTable.randommountlist["Land"][j][1]) then
							_G["MRMGUIMainFrame_Mount_CheckButton"..i]:SetChecked(true)
							break
						end
					end
				end
				MRMNextPageButton:Enable()
				MRM_Total_MountsShown = 24
			else
				for i = 1, GetNumCompanions("MOUNT") do
					creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
					_G["MRMGUIMainFrame_MountLabel"..i]:SetText(i..". "..creatureName)
					_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Enable()
					_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Show()
					creatureName = string.lower(creatureName)
					for j = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
						if (creatureName == MountRandomMount_SavedTable.randommountlist["Flying"][j][1]) then
							_G["MRMGUIMainFrame_Mount_CheckButton"..i]:SetChecked(true)
							break
						end
					end
					for j = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
						if (creatureName == MountRandomMount_SavedTable.randommountlist["Land"][j][1]) then
							_G["MRMGUIMainFrame_Mount_CheckButton"..i]:SetChecked(true)
							break
						end
					end
				end
				MRMNextPageButton:Disable()
				MRM_Total_MountsShown = GetNumCompanions("MOUNT")
			end
			
			MRMMainFrame:Show()
		else
			print(MRMNoMountsAtAll)
		end
		
		MRMPrevPageButton:Disable()
		MRM_Frame_CurPAGENUM = 1;
		
	end
	
end

function MRMMountFrameColumn_SetWidth(frame, width)
	frame:SetWidth(width);
	getglobal(frame:GetName().."Middle"):SetWidth(width - 9);
end

function MRMFrameButton_AddMount_OnClick(self)
	local butnum = string.sub(self:GetName(), 34, string.len(self:GetName()))
	local BegM, _ = string.find((string.lower(_G["MRMGUIMainFrame_MountLabel"..butnum]:GetText())), " ")
	
	if (self:GetChecked()) then
		MountRandomMount_add(string.sub(string.lower(_G["MRMGUIMainFrame_MountLabel"..butnum]:GetText()), BegM+1, string.len(_G["MRMGUIMainFrame_MountLabel"..butnum]:GetText())))
		--print(butnum)
	else
		MountRandomMount_remove(string.sub(string.lower(_G["MRMGUIMainFrame_MountLabel"..butnum]:GetText()), BegM+1, string.len(_G["MRMGUIMainFrame_MountLabel"..butnum]:GetText())))
	end
end

function MRMNextPage_OnClick(self)
	local endnum
	local CurPageNum = MRM_Frame_CurPAGENUM
	for i = 1, 24 do
		_G["MRMGUIMainFrame_MountLabel"..i]:SetText("")
		_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Disable()
		_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Hide()
		_G["MRMGUIMainFrame_Mount_CheckButton"..i]:SetChecked(false)
	end
	if (GetNumCompanions("MOUNT") > (24*(CurPageNum+1))) then
		endnum =  24*(CurPageNum + 1)
	else
		endnum = GetNumCompanions("MOUNT")
		MRMNextPageButton:Disable()
	end
	local tt = 1
	for j = ((24 * CurPageNum)+1), endnum do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", j)
		
		_G["MRMGUIMainFrame_MountLabel"..tt]:SetText(j..". "..creatureName)
		_G["MRMGUIMainFrame_Mount_CheckButton"..tt]:Enable()
		_G["MRMGUIMainFrame_Mount_CheckButton"..tt]:Show()
		creatureName = string.lower(creatureName)
		for i = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
			if (creatureName == MountRandomMount_SavedTable.randommountlist["Flying"][i][1]) then
				_G["MRMGUIMainFrame_Mount_CheckButton"..tt]:SetChecked(true)
				break
			end
		end
		for i = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
			if (creatureName == MountRandomMount_SavedTable.randommountlist["Land"][i][1]) then
				_G["MRMGUIMainFrame_Mount_CheckButton"..tt]:SetChecked(true)
				break
			end
		end
		tt = tt + 1
	end
	MRMPrevPageButton:Enable()
	MRM_Frame_CurPAGENUM = MRM_Frame_CurPAGENUM + 1;
	--print(MRM_Frame_CurPAGENUM)
end

function MRMPrevPage_OnClick(self)
	if (MRM_Frame_CurPAGENUM == 2)  then
		MRMPrevPageButton:Disable()
		MRM_Frame_CurPAGENUM = 1
		MountRandomMount_GUI(false)
	else
		for i = 1, 24 do
			_G["MRMGUIMainFrame_MountLabel"..i]:SetText("")
			_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Disable()
			_G["MRMGUIMainFrame_Mount_CheckButton"..i]:Hide()
			_G["MRMGUIMainFrame_Mount_CheckButton"..i]:SetChecked(false)
		end
		local CurPageNum = MRM_Frame_CurPAGENUM
		local endnum =  24*(CurPageNum - 1)
		local tt = 1
		for i = ((24 * (CurPageNum-1))-23), endnum do
			creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
			_G["MRMGUIMainFrame_MountLabel"..tt]:SetText(i..". "..creatureName)
			_G["MRMGUIMainFrame_Mount_CheckButton"..tt]:Enable()
			_G["MRMGUIMainFrame_Mount_CheckButton"..tt]:Show()
			creatureName = string.lower(creatureName)
			for j = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
				if (creatureName == MountRandomMount_SavedTable.randommountlist["Flying"][j][1]) then
					_G["MRMGUIMainFrame_Mount_CheckButton"..tt]:SetChecked(true)
					break
				end
			end
			for j = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
				if (creatureName == MountRandomMount_SavedTable.randommountlist["Land"][j][1]) then
					_G["MRMGUIMainFrame_Mount_CheckButton"..tt]:SetChecked(true)
					break
				end
			end
			tt = tt + 1
		end
		MRM_Frame_CurPAGENUM = MRM_Frame_CurPAGENUM - 1;
		MRMNextPageButton:Enable();
	end
	
end

function MRMMainFrame_OnLoad()
	tinsert(UISpecialFrames,"MRMMainFrame");
	UIPanelWindows['MRMMainFrame'] = {area = 'center', pushable = 0};
	MRMGUIMainFrame_MountHeader1:SetText(RED_FONT_COLOR_CODE.."Mount Name|r")
	MRMGUIMainFrame_MountHeader2:SetText(RED_FONT_COLOR_CODE.."Mount Name|r")
	MRMGUIMainFrame_InListHeader1:SetText(GREEN_FONT_COLOR_CODE.."In List|r")
	MRMGUIMainFrame_InListHeader2:SetText(GREEN_FONT_COLOR_CODE.."In List|r")
	--print(MountRandomMount_Reseed)
	MRMMainFrame:RegisterEvent("COMPANION_LEARNED")
	MRMMainFrame:SetScript("OnEvent", MountRandomMount_Reseed)
				       --COMPANION_LEARNED
	
end

