MountRandomMount = { } 
MountRandomMount_SavedTable = { }
MountRandomMount_SavedTable.randommountlist = {  }
MountRandomMount_SavedTable.randommountlist["Flying"] = { }
MountRandomMount_SavedTable.randommountlist["Land"] = {}
MountRandomMount_SeaTurtleIHave = false
MountRandomMount_SeaTurtleID = 0
MountRandomMount_CheckedForST = false
MountRandomMount.version = "3.0.3"
MountRandomMount.btn = CreateFrame("Button", "MRMSecureButton", UIParent, "SecureActionButtonTemplate");
local bind1, bind2
MountRandomMount_SavedTable.MRMDruid_CatInside = false
local found1 = false
local found2 = false

function MountRandomMount_Reseed()
	local mountcount = GetNumCompanions("MOUNT")
	local id
	for j = 1, mountcount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", j)
		local amount = string.lower(creatureName)
		for i = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
			if (amount == MountRandomMount_SavedTable.randommountlist["Flying"][i][1]) then
				MountRandomMount_SavedTable.randommountlist["Flying"][i][2] = j
			end
		end
		for i = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
			if (amount == MountRandomMount_SavedTable.randommountlist["Land"][i][1]) then
				MountRandomMount_SavedTable.randommountlist["Land"][i][2] = j
			end
		end
	end
	print(MRMReseedPrint)
end

function MountRandomMount_MountRandom()
	if (MountRandomMount_SavedTable.randommountlist == nil) or ((MountRandomMount_SavedTable.randommountlist["Flying"] == nil) and (MountRandomMount_SavedTable.randommountlist["Land"] == nil)) or ((#MountRandomMount_SavedTable.randommountlist["Flying"] == 0) and (#MountRandomMount_SavedTable.randommountlist["Land"] == 0)) then
		print(MRMNoMounts)
		return
	end
	--print("test")
	--[[local mounts = {}
	local mountcount = GetNumCompanions("MOUNT")
	for i = 1, mountcount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
		local lowerCN = string.lower(creatureName)
		for j = 1, #MountRandomMount_SavedTable.randommountlist do
			if (MountRandomMount_SavedTable.randommountlist[i] == lowerCN) then
				mounts[lowerCN] = i
			end
		end
	end]]
	--local randomnum = random(#MountRandomMount_SavedTable.randommountlist)
	if IsMounted() then 
		Dismount() 
		return
	end
	if(IsSwimming()) then
		if (MountRandomMount_CheckedForST == false) then
			local mountcount = GetNumCompanions("MOUNT")
			for i = 1, mountcount do
				creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
				
				if(creatureName == MRMSeaTurtle) then
					MountRandomMount_SeaTurtleIHave = true
					MountRandomMount_SeaTurtleID = i
				end
			end
			MountRandomMount_CheckedForST = true
		end
		if(MountRandomMount_SeaTurtleIHave) then
			CallCompanion("MOUNT", MountRandomMount_SeaTurtleID)
		else
			print("You don't have a sea turtle, calling random land mount.")
			if (MountRandomMount_SavedTable.randommountlist["Land"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Land"] == 0) then
				print(MRMNoMounts)
				return
			else
				CallCompanion("MOUNT", MountRandomMount_SavedTable.randommountlist["Land"][(random(#MountRandomMount_SavedTable.randommountlist["Land"]))][2])
				return
			end
		end
	elseif (GetZoneText()  == MRMWintergrasp) then
		local MRMWG_Active = (not GetWintergraspWaitTime())
		--print(MRMWG_Active)
		if (MRMWG_Active) then
			if (MountRandomMount_SavedTable.randommountlist["Land"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Land"] == 0) then
				print(MRMNoMounts)
				return
			else
				CallCompanion("MOUNT", MountRandomMount_SavedTable.randommountlist["Land"][(random(#MountRandomMount_SavedTable.randommountlist["Land"]))][2])
				return
			end
		else
			if (MountRandomMount_SavedTable.randommountlist["Flying"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Flying"] == 0) then
				if (MountRandomMount_SavedTable.randommountlist["Land"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Land"] == 0) then
					print(MRMNoMounts)
					return
				else
					print(MRMNoFlyingMountsLand)
					CallCompanion("MOUNT", MountRandomMount_SavedTable.randommountlist["Land"][(random(#MountRandomMount_SavedTable.randommountlist["Land"]))][2])
					return
				end
			end
			CallCompanion("MOUNT", MountRandomMount_SavedTable.randommountlist["Flying"][(random(#MountRandomMount_SavedTable.randommountlist["Flying"]))][2])
		end
	elseif(not IsFlyableArea()) then
		if (MountRandomMount_SavedTable.randommountlist["Land"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Land"] == 0) then
			print(MRMNoLandMounts)
			return
		end
		CallCompanion("MOUNT", MountRandomMount_SavedTable.randommountlist["Land"][(random(#MountRandomMount_SavedTable.randommountlist["Land"]))][2])
	else
		if (MountRandomMount_SavedTable.randommountlist["Flying"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Flying"] == 0) then
			if (MountRandomMount_SavedTable.randommountlist["Land"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Land"] == 0) then
				print(MRMNoMounts)
				return
			else
				print(MRMNoFlyingMountsLand)
				CallCompanion("MOUNT", MountRandomMount_SavedTable.randommountlist["Land"][(random(#MountRandomMount_SavedTable.randommountlist["Land"]))][2])
				return
			end
		end
		CallCompanion("MOUNT", MountRandomMount_SavedTable.randommountlist["Flying"][(random(#MountRandomMount_SavedTable.randommountlist["Flying"]))][2])
		
	end
end

function MountRandomMount_LandOnly()
	if (MountRandomMount_SavedTable.randommountlist == nil) or ( (MountRandomMount_SavedTable.randommountlist["Land"] == nil)) or ((#MountRandomMount_SavedTable.randommountlist["Land"] == 0)) then
		print(MRMNoMounts)
		return
	end
	CallCompanion("MOUNT", MountRandomMount_SavedTable.randommountlist["Land"][(random(#MountRandomMount_SavedTable.randommountlist["Land"]))][2])
end

function MRM_OnPostClick()
	MountRandomMount.btn:SetAttribute("spell", nil)
end

function MountRandomMount_TravelForm(localizedClass, localizedRace)
	found1= false
	found2= false
	local kk1 =0
	local kk2 = 0
	MountRandomMount.btn:SetAttribute("type", "spell")
	MountRandomMount.btn:SetScript("PreClick", MRM_OnPreClick)
	MountRandomMount.btn:SetScript("PostClick", MRM_OnPostClick)
	MountRandomMount.btn:SetAttribute("spell", nil)
	for k = 1, GetNumBindings(), 1 do
		local command, key1, key2 = GetBinding(k);
		if (command and command == "MRMTravelTRIGGER") then
			if (key1) then
				bind1 = key1
				SetBindingClick(bind1, "MRMSecureButton")
			end
			if (key2) then
				bind2 = key2
				SetBindingClick(bind2, "MRMSecureButton")
			end
		end
	end
end

function MRM_OnPreClick()
	localizedClass, englishClass = UnitClass("player")
	if (localizedClass == MRMShaman) then
		local name2, _, _, _, _, _, _, _, _ = GetSpellInfo(2645)
		local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
		if (name ~= nil) then
			MountRandomMount.btn:SetAttribute("spell", name)	
		else
			print(MRMGhostWolf)
		end
	elseif (localizedClass == MRMDruid) then
		local isInstance, instanceType = IsInInstance()
		local inside = IsIndoors()
		if(IsSwimming()) then
			local name2, _, _, _, _, _, _, _, _ = GetSpellInfo(1066)
			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
			if (name ~= nil) then
				MountRandomMount.btn:SetAttribute("spell", name)	
			else
				print(MRMAcquaForm)
			end
		elseif ((inside ~= nil) or (isInstance ~= nil)) and (MountRandomMount_SavedTable.MRMDruid_CatInside == true) then
			local name2, _, _, _, _, _, _, _, _ = GetSpellInfo(768)
			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
			if (name ~= nil) then
				MountRandomMount.btn:SetAttribute("spell", name)	
			else
				print(MRMCatForm)
			end
		elseif (GetZoneText()  == MRMWintergrasp) then
			MRMWG_Active = (not GetWintergraspWaitTime())
			if (MRMWG_Active) then
				local name2, _, _, _, _, _, _, _, _ = GetSpellInfo(783)
				local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
				if (name ~= nil) then
					MountRandomMount.btn:SetAttribute("spell", name)	
				else
					print(MRMTravelForm)
				end
			else
				local name2, _, _, _, _, _, _, _, _ = GetSpellInfo(40120)
				local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
				if (name ~= nil) then
					MountRandomMount.btn:SetAttribute("spell", name)		
				else
					name2, _, _, _, _, _, _, _, _ = GetSpellInfo(33943)
					name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
					if (name ~= nil) then
						MountRandomMount.btn:SetAttribute("spell", name)	
					else
						name2, _, _, _, _, _, _, _, _ = GetSpellInfo(783)
						name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
						if (name ~= nil) then
							MountRandomMount.btn:SetAttribute("spell", name)	
						else
							print(MRMFlighForm)
						end
					end
				end
			end
		elseif((GetRealZoneText()==MRMDalaran) or not IsFlyableArea()) and (GetMinimapZoneText() ~= MRMKrasusLanding) then
			local name2, _, _, _, _, _, _, _, _ = GetSpellInfo(783)
			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
			if (name ~= nil) then
				MountRandomMount.btn:SetAttribute("spell", name)	
			else
				print(MRMTravelForm)
			end
		else
			local name2, _, _, _, _, _, _, _, _ = GetSpellInfo(40120)
			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
			if (name ~= nil) then
				MountRandomMount.btn:SetAttribute("spell", name)		
			else
				name2, _, _, _, _, _, _, _, _ = GetSpellInfo(33943)
				name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
				if (name ~= nil) then
					MountRandomMount.btn:SetAttribute("spell", name)	
				else
					name2, _, _, _, _, _, _, _, _ = GetSpellInfo(783)
					name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(name2)
					if (name ~= nil) then
						MountRandomMount.btn:SetAttribute("spell", name)	
					else
						print(MRMFlighForm)
					end
				end
			end
		end
	end
	--SetBindingClick("MRMSecureButton")
end

function MountRandomMount_add(amount)
	local foundmount = false
	local mountcount = GetNumCompanions("MOUNT")
	local id
	for i = 1, mountcount do
		creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
		local lowerCN = string.lower(creatureName)
		--print("]"..amount..'[ - ]'..creatureName.."[")
		if (amount == lowerCN) then
			foundmount = true
			id = i
			break
		end
	end
	if (foundmount == true) then
		local flying
		local headlesshorse = false
		local _, name, spellID = GetCompanionInfo("MOUNT",id) 
		
		GameTooltip_SetDefaultAnchor(MountRandomMountTooltip, UIParent)
		MountRandomMountTooltip:SetHyperlink("spell:"..spellID) 				
		for i = 1, MountRandomMountTooltip:NumLines() do 
			local text = _G["MountRandomMountTooltipTextLeft"..i]:GetText()
			for word in string.gmatch(text, "%S+") do
				if strfind(word, MRMOutland) then
					flying = true
					break
				elseif strfind(word, MRMNorthrend) then
					flying = true
					break
				elseif strfind(word, MRMHeadlessKeywordLocation) then
					headlesshorse = true
					break
				elseif strfind(word, MRMHeadlessHorsemanSpecific) then
					headlesshorse = true
					break
				elseif strfind(word, MRMX53TouringRocket) then
					flying = true
					break
				else
					flying = false
				end
			end
		end
		MountRandomMountTooltip:Hide()
		local mounttoadd = {amount, id}
		if (flying == true) then
			
			if (MountRandomMount_SavedTable.randommountlist == nil) or (MountRandomMount_SavedTable.randommountlist["Flying"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Flying"] == 0) then
				print(amount.." "..MRMFlyingAdded)
				MountRandomMount_SavedTable.randommountlist["Flying"][1] = mounttoadd
			else
				for j = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
					if (MountRandomMount_SavedTable.randommountlist["Flying"][j][1] == amount) then
						print(amount.." "..MRMAlreadyInList)
						return
					end
				end
				print(amount.." "..MRMFlyingAdded)
				MountRandomMount_SavedTable.randommountlist["Flying"][#MountRandomMount_SavedTable.randommountlist["Flying"]+1] = mounttoadd
			end
		elseif(headlesshorse == true) then
			if (MountRandomMount_SavedTable.randommountlist == nil) or (MountRandomMount_SavedTable.randommountlist["Flying"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Flying"] == 0) then
				print(amount.." "..MRMFlyingAdded)
				MountRandomMount_SavedTable.randommountlist["Flying"][1] = mounttoadd
			else
				for j = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
					if (MountRandomMount_SavedTable.randommountlist["Flying"][j][1] == amount) then
						print(amount.." "..MRMAlreadyInList)
						return
					end
				end
				print(amount.." "..MRMFlyingAdded)
				MountRandomMount_SavedTable.randommountlist["Flying"][#MountRandomMount_SavedTable.randommountlist["Flying"]+1] = mounttoadd
			end
			if (MountRandomMount_SavedTable.randommountlist == nil) or (MountRandomMount_SavedTable.randommountlist["Land"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Land"] == 0) then
				print(amount.." "..MRMLandAdded)
				MountRandomMount_SavedTable.randommountlist["Land"][1] = mounttoadd
			else
				for j = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
					if (MountRandomMount_SavedTable.randommountlist["Land"][j][1] == amount) then
						print(amount.." "..MRMAlreadyInList)
						return
					end
				end
				print(amount.." "..MRMLandAdded)
				MountRandomMount_SavedTable.randommountlist["Land"][((#MountRandomMount_SavedTable.randommountlist["Land"])+1)] = mounttoadd
			end
		else
			if (MountRandomMount_SavedTable.randommountlist == nil) or (MountRandomMount_SavedTable.randommountlist["Land"] == nil) or (#MountRandomMount_SavedTable.randommountlist["Land"] == 0) then
				print(amount.." "..MRMLandAdded)
				MountRandomMount_SavedTable.randommountlist["Land"][1] = mounttoadd
			else
				for j = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
					if (MountRandomMount_SavedTable.randommountlist["Land"][j][1] == amount) then
						print(amount.." "..MRMAlreadyInList)
						return
					end
				end
				print(amount.." "..MRMLandAdded)
				MountRandomMount_SavedTable.randommountlist["Land"][((#MountRandomMount_SavedTable.randommountlist["Land"])+1)] = mounttoadd
			end
		end
	else
		print(MRMNoMountSpecified.." "..amount)
	end
end

function MountRandomMount_remove(amount)
	if (MountRandomMount_SavedTable.randommountlist == nil) or ((MountRandomMount_SavedTable.randommountlist["Flying"] == nil) and (MountRandomMount_SavedTable.randommountlist["Land"] == nil)) or ((#MountRandomMount_SavedTable.randommountlist["Flying"] == 0) and (#MountRandomMount_SavedTable.randommountlist["Land"] == 0)) then
		print(MRMNoMounts)
		return
	end
	for i = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
		if (amount == MountRandomMount_SavedTable.randommountlist["Flying"][i][1]) then
			table.remove(MountRandomMount_SavedTable.randommountlist["Flying"], i)
			print(amount.." "..MRMFlyingRemoved)
			return
		end
	end
	for i = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
		if (amount == MountRandomMount_SavedTable.randommountlist["Land"][i][1]) then
			table.remove(MountRandomMount_SavedTable.randommountlist["Land"], i)
			print(amount.." "..MRMLandRemoved)
			return
		end
	end
	print(amount.." "..MRMNoExist)
end

function MountRandomMount_list()
	if (MountRandomMount_SavedTable.randommountlist == nil) or ((MountRandomMount_SavedTable.randommountlist["Flying"] == nil) and (MountRandomMount_SavedTable.randommountlist["Land"] == nil)) or ((#MountRandomMount_SavedTable.randommountlist["Flying"] == 0) and (#MountRandomMount_SavedTable.randommountlist["Land"] == 0)) then
		print(MRMNoMounts)
		return
	end
	print(MRMListTitle)
	print(MRMListFlyingTitle)
	if (#MountRandomMount_SavedTable.randommountlist["Flying"] == 0) then	
		print(MRMNoFlyingMounts)
	else
		for i = 1, #MountRandomMount_SavedTable.randommountlist["Flying"] do
			print("   "..i..". "..MountRandomMount_SavedTable.randommountlist["Flying"][i][1])
		end
	end
	print(" ")
	print(MRMListLandTitle)
	if (#MountRandomMount_SavedTable.randommountlist["Land"] == 0) then	
		print(MRMNoLandMounts)
	else
		for i = 1, #MountRandomMount_SavedTable.randommountlist["Land"] do
			print("   "..i..". "..MountRandomMount_SavedTable.randommountlist["Land"][i][1])
		end
	end
end

CreateFrame("GameTooltip","MountRandomMountTooltip",UIParent,"GameTooltipTemplate")

SLASH_RANDOMMOUNT1 = "/rdm"
SlashCmdList["RANDOMMOUNT"] = function(msg)
	if( msg ) then
		local command2 = string.lower(msg);
		local command, rest2 = command2:match("^(%S*)%s*(.-)$")
		local rest
		local ibeg, _= string.find(rest2, "%[")
		local _, iend = string.find(rest2, "%]")
		if (ibeg ~= nil) and (iend ~= nil) then
			rest = string.sub(rest2, ibeg+1, (iend -1))
		end
		if (rest == MRMBronzeDrake) then
			rest = MRMBronzeDrakeMount
		end
		--print(rest2)
		--print("]"..rest.."[")
		if (command == MRMRandom) then
			MountRandomMount_MountRandom()
		elseif (command == MRMAdd) then
			MountRandomMount_add(rest)
		elseif (command == MRMRemove) then
			MountRandomMount_remove(rest)
		elseif (command == MRMList) then
			MountRandomMount_list()
		elseif (command == MRMGui) then
			if (MRMMainFrame:IsVisible()) then
				MountRandomMount_GUI(true)
			else
				MountRandomMount_GUI(false)
			end
		elseif (command == MRMCatInside) then
			local localizedClass, englishClass = UnitClass("player")
			if (localizedClass == MRMDruid) then
				if (MountRandomMount_SavedTable.MRMDruid_CatInside) then
					print(MRMCatInsideFalse)
					MountRandomMount_SavedTable.MRMDruid_CatInside = false
				else
					print(MRMCatInsideTrue)
					MountRandomMount_SavedTable.MRMDruid_CatInside = true
				end
			else
				print(MRMNotADruid)
			end
		elseif (command == MRMReseed) then
			MountRandomMount_Reseed()
		else
			print(MRMCommands)
		end
	end
end
--/run if IsMounted()then DisMount() end local t if((GetRealZoneText()==MRMDalaran) or (GetZoneText()==MRMWintergrasp) or not IsFlyableArea()) then t={3,8,9,21} else t={2,5,11} end CallCompanion("MOUNT",t[random(#t)]) 